(function () {
  'use strict';

  function AppCtrl($scope) {
  }

  function AppRun($rootScope, $ionicPopup, $state, $cordovaGoogleAnalytics) {
    $rootScope.$on('$stateChangeStart', function (event, toState, toParams, fromState, fromParams) {
      console.log('$stateChangeStart to ' + toState.to + '- fired when the transition begins. toState,toParams : \n', toState, toParams);
      switch(toState.name){
        case 'login':
        case 'my.reservation':
        case 'my.reservations':
        case 'my.newreservation':
        case 'map':
        default: $rootScope.$broadcast('loading:show');
      }
      //Tracking app with Google Analytics
      ionic.Platform.ready(function () {
        if(ionic.Platform.isWebView()) {
          $cordovaGoogleAnalytics.trackView(toState.name);
        }
      });
    });
    $rootScope.$on('$stateChangeError', function (event, toState, toParams, fromState, fromParams, rejected) {

      if ( rejected === 'NoCarFound') {
        $ionicPopup.alert({
          title: 'Проблема',
          template: 'Приносим свои извинения, но данный автомобиль не доступен для бронирования.'
        });
      } else {
        $ionicPopup.alert({
          title: 'Проблема',
          template: 'Мы не можем связаться с сервером, возможно проблема в связи. Попробуйте повторить чуть позже'
        });
      }
      $rootScope.$broadcast('loading:hide');
      console.log('$stateChangeError - fired when an error occurs during transition.');
      console.log(arguments);
      try {
        console.log(arguments[5].stack);
      } catch (e) {

      }
    });
    $rootScope.$on('$stateChangeSuccess', function (event, toState, toParams, fromState, fromParams) {
      console.log('$stateChangeSuccess to ' + toState.name + '- fired once the state transition is complete.');
      $rootScope.$broadcast('loading:hide');
    });
    $rootScope.$on('$viewContentLoading',function(event, viewConfig){
     // runs on individual scopes, so putting it in "run" doesn't work.
     console.log('$viewContentLoading - view begins loading - dom not rendered',viewConfig);
    });
    $rootScope.$on('$viewContentLoaded', function (event) {
      console.log('$viewContentLoaded - fired after dom rendered', event);
      //$rootScope.$broadcast('loading:hide');
      //$rootScope.stopLoading();
    });
    $rootScope.$on('$stateNotFound', function (event, unfoundState, fromState, fromParams) {
      console.log('$stateNotFound ' + unfoundState.to + '  - fired when a state cannot be found by its name.');
      console.log(unfoundState, fromState, fromParams);
    });
    $rootScope.$on("$cordovaLocalNotification:click", function (event, notification, state) {
      console.log("notification id:" + notification.id + " state: " + state);
      $state.go('my.reservation', {id: notification.data});
    });
  }

  angular.module('app')
    .controller('AppCtrl', AppCtrl)
    .run(AppRun)
}());