(function () {
  'use strict';


  function LoginCtrl($scope, $http, $state, $ionicHistory, $ionicLoading, $ionicPopup, User, $cordovaInAppBrowser, sf) {

    var vm = this;

    $scope.email = '';

    function goReservations() {
      $ionicHistory.nextViewOptions({
        historyRoot: true,
        disableBack: true
      });

      // Transition to reservations state
      $state.go('my.reservations');
      return;
    }


    $scope.$on('auth:logged', goReservations);

    /**
     * Login into system using MetaVera API
     */
    vm.doLogin = function() {
      // Send login and password to API
      User.login($scope.login, $scope.password).then(function(data) {
        // If correct
        if ( data == '1') {
          // Clear history and do not allow to go back
          goReservations();
        }
      }, function(error) {
        // Draw a message otherwise
        if ('code' in error && error.code === "0") {
          $scope.message = sf.translate('login.alert.wrong_data');
        } else if ('status' in error && error.status === 0) {
          $scope.message = sf.translate('login.alert.server_off');
        } else {
          $scope.message = sf.translate('login.alert.server_bad');
        }
      });
    };


    /**
     * Move to login screen
     */
    vm.goLogin = function () {
      $state.go('login');
    };

    vm.openRegistration = function () {
      $cordovaInAppBrowser.open('https://www.streetcar.ru/registration/', '_system', {location: 'yes'});
    }

  }

  function PasswordRestoreCtrl($scope, $http, $state, $ionicHistory, $ionicLoading, $ionicPopup, User, $cordovaInAppBrowser, sf) {
    var vm = this;

    $scope.email = '';

    /**
     * Restoring username/password
     */
    vm.doRestorePassword = function () {
      // Something need to be done here

      //mail validating
      var valid = /^[\w\.\d-_]+@[\w\.\d-_]+\.\w{2,4}$/i;

      //if (valid.test($scope.email)) {

      $ionicLoading.show();
      $http.get("https://www.streetcar.ru/restore_password/", {params: {email: document.getElementById('emailRestore').value}}).then(function (data) {

        if (/success/.test(data.data)) {
          $scope.message = sf.translate('login.restore.sent');
        }

        if (/not found/.test(data.data)) {
          $scope.message = sf.translate('login.restore.badmail');
        }

        if (/error/.test(data.data)) {
            $scope.message = sf.translate('login.restore.error');
        }

      }, function (error) {
        $scope.message = sf.translate('login.restore.error');
      }).then(function () {
        $ionicLoading.hide();
      });

      /*} else {
       var alertPopup = $ionicPopup.alert({
       title: 'Ошибочка!',
       template: 'Неправильный тип Email. Обычно они выглядят так: sample@dude.com'
       });
       }*/
      return false;
    };
  }

  angular
    .module('app.login')
    .controller('LoginCtrl', LoginCtrl)
    .controller('PasswordRestoreCtrl', PasswordRestoreCtrl);
}());
