(function () {
    'use strict';

    function getVehicles(MetaVera, $stateParams, $q, DriftData) {
        return MetaVera.searchAvailableCars(4, $stateParams['lat'], $stateParams['long']).then(function (a) {
            var id = $stateParams['id'];

            var vehicles = _.filter(a.DBRankedStacks, function (i) {
                return i.DBEntityStack.DBEntityVehicle.id === id
            });

            if (vehicles.length > 0) {
                return a;
            } else {
                return $q.reject('NoCarFound');
            }
        });
    }

    function DriftData(sf, MetaVera) {
        return {
            parking: { pDescr: '', pPlace: '' },
            carLocation: { lat: '', long: '' },
            myLocation: { lat: '', long: '' },
            time: {
                start: sf.roundTo(MetaVera.getTime() + 900, 60 * MetaVera.tripTimeResolution),
                end: sf.roundTo((MetaVera.getTime() + 60 * 60 * 4 * 1) + 900, 60 * MetaVera.tripTimeResolution)
            }
        };
    }

    function newReservationConfig($stateProvider) {
      $stateProvider

      .state('my.filter', {
          url: "/filter?car&long&lat&name",
          parent: 'my',
          views: {
            'content': {
              templateUrl: "templates/filter/index.html",
              controller: "filterCtrl as vm"
            }
          }
      })

      .state('my.filtercars', {
          url: "/filter/cars?long&lat&name",
          parent: 'my',
          views: {
            'content': {
              templateUrl: "templates/filter/cars.html",
              controller: "filterCarsCtrl as vm"
            }
          }
      })

      .state('my.filterplaces', {
          url: "/filter/places?car&long&lat&name",
          parent: 'my',
          views: {
            'content': {
              templateUrl: "templates/filter/places.html",
              controller: "filterPlacesCtrl as vm"
            }
          }
      })

      .state('my.newreservation', {
          url: "/newreservation/:id?lat&long",
          parent: 'my',
          views: {
            'content': {
              templateUrl: "templates/filter/reservation.html",
              controller: "newReservationCtrl as vm"
            }
          },
          resolve: {
            Vehicle: getVehicles
          }
      })

      .state('my.parking', {
          url: "/newreservation/:id/parking",
          parent: 'my',
          views: {
            'content': {
              templateUrl: "templates/filter/parking.html",
              controller: "parkingCtrl as vm"
            }
          }
      });
    }

    angular
        .module('app.newreservation', [
            'ui.router',
            'app.reservations',
            'ionic',
            'app.services.metavera',
            'app.services.sf',
            'app.pricing',
            'app.map',
            'angularMoment',
            'ngCordova.plugins.datePicker'
        ])
        .config(newReservationConfig)
        .factory('DriftData', DriftData);

}());