(function () {
    'use strict';

    function registrationConfig($stateProvider) {
        $stateProvider

            .state('registration', {
                url: "/registration",
                abstract: true,
                templateUrl: "templates/registration/index.html"
            })

            .state('registration.step1', {
                url: "/1",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step1.html",
                        controller: "registrationCtrl as vm"
                    }
                }
            })

            .state('registration.step2', {
                url: "/2",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step2.html",
                        controller: "registrationCtrl as vm"
                    }
                }
            })
            .state('registration.step3', {
                url: "/3",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step3.html",
                        controller: "registrationCtrl as vm"
                    }
                }
            })
            .state('registration.step4', {
                url: "/4",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step4.html",
                        controller: "registrationAgreementCtrl as vm"
                    }
                }
            })
            .state('registration.step5', {
                url: "/5",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step5.html",
                        controller: "registrationPhoneVerifyCtrl as vm"
                    }
                }
            })
            .state('registration.step6', {
                url: "/6",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/step6.html",
                        controller: "registrationCtrl as vm"
                    }
                }
            })
            .state('registration.finish', {
                url: "/finish",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/finish.html",
                        controller: "registrationFinishCtrl as vm"
                    }
                }
            })
            .state('registration.license', {
                url: "/license",
                parent: 'registration',
                views: {
                    'registrationPage': {
                        templateUrl: "templates/registration/license.html",
                        controller: "registrationLicenseCtrl as vm"
                    }
                }
            })

    }

    angular
        .module('app.registration', ['ionic', 'app.services.metavera', 'app.services.registration', 'app.services.user', 'app.services.sf', 'ngCordova'])
        .config(registrationConfig)

}());