(function () {
    'use strict';

    function registrationCtrl($scope, $state, $ionicPopup, $ionicLoading, $http, RegistrationService, $cordovaCamera, sf) {
        var vm = this;

        vm.hideLabel = function(link){
            document.getElementById(link).style.display = 'none';
        };

        vm.ocr = function () {
            if(ionic.Platform.isWebView()){
                window.cordova.exec(
                    function (result) {
                        console.log(result);
                        vm.lastname = result[0];
                        var bla = result[2].slice(' ');
                        vm.firstname = bla[0];
                        vm.middlename = bla[1];
                    },
                    function (error) {
                        console.log(error);
                    },
                    'OCRAPI',
                    'launchOCR',
                    []);
            }
        };

        vm.changeTarif = function(){
            $ionicLoading.show();
            var exp = document.getElementById('exp').value;

            if(exp != '') {
                RegistrationService.takePlans().then(function (data) {
                    if (data) {
                        var plan = data.data;
                        var planId = Object.keys(plan);

                        if (exp >= 3) {
                            document.getElementById('plan').value =  sf.translate('reg.rate.your') + ': ' + plan[planId[0]];
                            vm.accountRatePlan = planId[0];
                        } else {
                            document.getElementById('plan').value = sf.translate('reg.rate.your') + ': ' + plan[planId[1]];
                            vm.accountRatePlan = planId[1];
                        }
                        $ionicLoading.hide();
                    }
                });
            } else {
                $ionicLoading.hide();
            }
        };

        function b64toBlob(b64Data, contentType, sliceSize) {
            contentType = contentType || '';
            sliceSize = sliceSize || 512;

            var byteCharacters = atob(b64Data);
            var byteArrays = [];

            for (var offset = 0; offset < byteCharacters.length; offset += sliceSize) {
                var slice = byteCharacters.slice(offset, offset + sliceSize);

                var byteNumbers = new Array(slice.length);
                for (var i = 0; i < slice.length; i++) {
                    byteNumbers[i] = slice.charCodeAt(i);
                }

                var byteArray = new Uint8Array(byteNumbers);

                byteArrays.push(byteArray);
            }

            var blob = new Blob(byteArrays, {type: contentType});
            return blob;
        }

        vm.passportUploaded = false;

        vm.goStep2 = function () {
            $ionicLoading.show();
            if(vm.license == true) {
                RegistrationService.registerUser({
                    email: vm.email,
                    firstname: vm.firstname,
                    lastname: vm.lastname,
                    middlename: vm.middlename,
                    password: vm.password,
                    passportNum: vm.passportNum,
                    passportCity: vm.passportCity,
                    passportAddress: vm.passportAddress,
                    passportIssueAddress: vm.passportIssueAddress,
                    address: vm.address,
                    tel: vm.tel,
                    drivingExp: vm.drivingExp,
                    applicantPromotionsCode: vm.applicantPromotionsCode,
                    accountRatePlan: vm.accountRatePlan
                }).then(function () {
                    $ionicLoading.hide();
                    $state.go('registration.step2');
                }, function (error) {
                    $ionicLoading.hide();
                    sf.alert(error.message);
                });
            } else {
                $ionicLoading.hide();
                sf.alert(sf.translate('reg.error'));
            }
        };

        vm.goStep3 = function () {
            $state.go('registration.step3');
        };
        vm.goStep4 = function () {

            $state.go('registration.step4');
        };
        vm.goStep5 = function () {

            $state.go('registration.step5');
        };
        vm.goStep6 = function () {

            $state.go('registration.step6');
        };

        vm.fillStep1 = function () {
            vm.email = 'm0rfik@mail.ru';
            vm.firstname = 'Антон';
            vm.lastname = 'Шалейников';
            vm.middlename = "Сергеевич";
            vm.password = "123";
            vm.passwordConfirm = "123";
            vm.passportNum = 12398123;
            vm.passportCity = "Санкт Петербург";
            vm.passportIssueAddress = "1 отдел милиции СанктПетербурга";
            vm.passportAddress="3-я улица Строителей д 5 кв 12";
            vm.tel = 375298642914;
            vm.drivingExp = 3;
        };

        vm.takePicture = function () {
            var options = {};
            try {
                options = {
                    quality: 90,
                    destinationType: Camera.DestinationType.DATA_URL,
                    sourceType: Camera.PictureSourceType.CAMERA,
                    allowEdit: false,
                    encodingType: Camera.EncodingType.JPEG,
                    targetHeight: 1920,
                    saveToPhotoAlbum: false
                };
            } catch (e) {
                // Avoid no cordova error
                $ionicLoading.hide();
            }

            return $cordovaCamera.getPicture(options).then(function (imageData) {
                var image = document.getElementById('cameraPicture');
                image.src = "data:image/png;base64," + imageData;
                return imageData;
            }, function (err) {
                // error
                $ionicLoading.hide();
                sf.alert(sf.translate('photo.error'));
            });
        };

        vm.uploadPassport = function() {
            $ionicLoading.show();
            vm.takePicture().then(function(data) {
                if(data) {
                    // Upload passport image
                    RegistrationService.sendPassport(b64toBlob(data, 'image/png')).then(function () {
                        $ionicLoading.hide();
                        vm.passportUploaded = true;
                        vm.goStep3();
                    }, function (err) {
                        console.log(err);
                        $ionicLoading.hide();
                        sf.alert(sf.translate('photo.error'));
                    });
                } else {
                    $ionicLoading.hide();
                }
            });
        };

        vm.uploadLicense = function() {
            $ionicLoading.show();
            vm.takePicture().then(function(data) {
                if(data) {
                    // Upload passport image
                    RegistrationService.sendLicense(b64toBlob(data, 'image/png')).then(function () {
                        $ionicLoading.hide();
                        vm.passportUploaded = true;
                        vm.goStep4();
                    }, function (err) {
                        console.log(err);
                        $ionicLoading.hide();
                        sf.alert(sf.translate('photo.error'));
                    });
                } else {
                    $ionicLoading.hide();
                }
            });
        };

        vm.saveCardCredentials = function() {
            $ionicLoading.show();
            RegistrationService.saveCardData({
                cardNum: vm.cardNum,
                cardName: vm.cardName,
                cardMonth: vm.cardMonth,
                cardYear: vm.cardYear,
                cardCvv2: vm.cardCvv2
            }).then(function () {
                $ionicLoading.hide();
                vm.goFinishRegistration();
            }, function () {
                $ionicLoading.hide();
                sf.alert(sf.translate('card.error'));
            });
        };

        vm.goFinishRegistration = function() {
            $state.go('registration.finish');
        };
    }

    function registrationAgreementCtrl($state, RegistrationService, $ionicLoading) {
        var vm = this;
        $ionicLoading.show();
        RegistrationService.getAgreement().then(function(data) {
            $ionicLoading.hide();
            vm.agreementText = data;
        });

        vm.goStep5 = function () {
            $state.go('registration.step5');
        };
    }

    function registrationLicenseCtrl($state, RegistrationService, $ionicLoading) {
        var vm = this;
        $ionicLoading.show();
        RegistrationService.getLicense('personal').then(function(data) {
            $ionicLoading.hide();
            vm.licenseText = data;
        });
    }

    function registrationPhoneVerifyCtrl($state, RegistrationService, $ionicPopup, $ionicLoading, sf) {
        var vm = this;
        $ionicLoading.show();
        RegistrationService.smsSend().then(function(data){
            data ? $ionicLoading.hide() : vm.sendError();
        });

        vm.verifyCode = function() {
            RegistrationService.smsVerify(vm.code).then(function() {
                // Success
                $ionicLoading.show();
                vm.goStep6();
            }, function(error) {
                // Failure
                $ionicLoading.show();
                vm.errorCode();
            })
        };

        vm.goStep6 = function () {

            $state.go('registration.step6');
        };

        vm.resendCode = function() {
            $ionicLoading.show();
            RegistrationService.smsAgain().then(function(data){
                $ionicLoading.hide();
            }, function(error){
                $ionicLoading.hide();
                sf.alert('sms.error_2');
            });
            return;
        };

        vm.errorCode = function() {
            $ionicLoading.hide();
            sf.translate('sms.error');
        };

    }

    function registrationFinishCtrl($state, RegistrationService) {
        var vm = this;
        vm.applicantId = RegistrationService.getAppId();
    }

    angular
        .module('app.registration')
        .controller('registrationCtrl', registrationCtrl)
        .controller('registrationAgreementCtrl', registrationAgreementCtrl)
        .controller('registrationLicenseCtrl', registrationLicenseCtrl)
        .controller('registrationFinishCtrl', registrationFinishCtrl)
        .controller('registrationPhoneVerifyCtrl', registrationPhoneVerifyCtrl);


}());