(function () {
  'use strict';

  function getCurrentReservation($stateParams, MetaVera) {
    var reservationId = $stateParams['id'];
    return MetaVera.fetchReservationById(reservationId);
  }

  function getCurrentReservationMessages($stateParams, MetaVera) {
    var reservationId = $stateParams['id'];
    return MetaVera.getReservationMessages(reservationId);
  }

  function getCurrentPosition($cordovaGeolocation) {
    return $cordovaGeolocation.getCurrentPosition({}).then(function (position) {
      return position;
    });
  }

  function DriftData() {
    return {
      parking: {pDescr: '', pPlace: ''},
      carLocation: {lat: '', long: ''},
      myLocation: { lat: '', long: '' }
    };
  }

  function ReservationsConfig($stateProvider) {
    $stateProvider

      .state('my.reservations', {
        url: "/reservations",
        parent: 'my',
        views: {
          'content': {
            templateUrl: "templates/reservation/index.html",
            controller: "ReservationsListCtrl as vm"
          }
        }
      })

      .state('my.reservation', {
        url: "/reservation/:id",
        parent: 'my',
        views: {
          'content': {
            templateUrl: "templates/reservation/reservation.html",
            controller: "ReservationCtrl as vm"
          }
        },
        resolve: {
          Reservation: getCurrentReservation,
          Position: getCurrentPosition
        }
      })
    ;
  }

  angular
    .module('app.reservations', [
      'ui.router',
      'ionic',
      'app.services.metavera',
      'app.services.sf',
      'app.pricing',
      'angularMoment',
      'ngCordova.plugins.datePicker',
      'pascalprecht.translate'
    ])
    .config(ReservationsConfig)
    .factory('DriftData', DriftData);

}());