(function() {
    'use strict';

    function SFService($state, moment, Cars, MetaVera, $filter, $ionicPopup, $cordovaLocalNotification) {

        this.serverDate = function(){
            return moment.unix(MetaVera.getTime()).format('YYYY-MM-DD');
        };

        this.serverHour = function(){
            return moment.unix(MetaVera.getTime()).format('HH:mm');
        };

        this.roundTo = function(num, div){
            return Math.floor(num/div)*div;
        };

        this.unixType = function (type, format) {
            return moment.unix(type).format(format);
        };

        this.diff = function(start, end) {
            return moment(end).diff(start, 'minutes');
        };

        this.timeType = function (type, format) {
            return moment(type).format(format);
        };

        this.timeRound = function (time) {
            var splitTime = time.split(':');

            if (splitTime[1] >= 53 && splitTime[0] != 23 && splitTime[0].indexOf('0') != false) {
                splitTime[0] = parseInt(splitTime[0]) + 1;
            } else if (splitTime[1] >= 53 & splitTime[0] != '09' && splitTime[0].indexOf('0') == false) {
                splitTime[0] = '0' + (parseInt(splitTime[0]) + 1);
            }

            var roundTime = splitTime[0] + ':' + (Math.round(splitTime[1] / 15) * 15) % 60;
            if (roundTime.length < 5) { roundTime = roundTime + '0'; }

            return roundTime;
        };

        this.getCarImage = function (res) {
            try {
                return Cars[res]['img'];
            } catch (E) {

            }

            try {
                return res.DBEntityStack.DBEntityVehicleType.thumbDesc;
            } catch (E) {

            }
            return '';

        };

        this.goPricingPage = function (id) {
            return $state.go('carPricing', {id: id});
        };

        this.getCarName = function(id) {
            try {
                return Cars[id]['descr'];
            } catch (E) { }
            return '';
        };

        this.getCarPrice = function(id) {
            try {
                return Cars[id]['price'];
            } catch (E) { }
            return '';
        };

        this.translate = function(text) {
            return $filter('translate')(text);
        };

        this.alert = function (alert) {
            return $ionicPopup.alert({
                title: this.translate('res.popup.attention'),
                template: alert,
                buttons: [{
                    text: this.translate('res.popup.back'),
                    type: 'button-positive'
                }]
            });
        };

        this.addNot = function(id, time, res, when){
            if(ionic.Platform.isWebView()) {
                return $cordovaLocalNotification.schedule({
                    id: when == 'start' ? id : id + 1,
                    at: time - res,
                    title: 'StreetCar',
                    text: this.translate('push.' + when),
                    data: id
                }).then(function () {
                    console.log('local add : notification added success');
                }, function(e){
                    console.log(e);
                });
            }
        };

        this.cancelNot = function(id){

        };

    }

    angular
      .module('app.services.sf', [])
      .service('sf', SFService);

}());
